﻿#pragma once
#include "DataStructures.h"

namespace std {
	template <> struct hash <Edge> {
		std::size_t operator () (const Edge& t_edge) const {
			std::size_t seed = 0;
			if (t_edge.nodes.first > t_edge.nodes.second) {
				seed ^= std::hash<int>() (t_edge.nodes.first) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
				seed ^= std::hash<int>() (t_edge.nodes.second) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
			}
			else {
				seed ^= std::hash<int>() (t_edge.nodes.second) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
				seed ^= std::hash<int>() (t_edge.nodes.first) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
			}
			return seed;
		}
	};
};


