#pragma once
#include <exception>
#include <string>

class NotFoundFiles : public std::exception {
private:
    std::string msg_err;
public:
    NotFoundFiles() :msg_err("Error: Not Found File") {};
    const char* what() const noexcept override {
        return msg_err.c_str();
    };
};


class IncorrectFormat : public std::exception {
private:
    std::string msg_err;
public:
    IncorrectFormat() :msg_err("Error: Incorrect Format") {};
    const char* what() const noexcept override {
        return msg_err.c_str();
    }
};

